package company

import (
	"context"
	"sorbet/internal/runtime"
	"sorbet/internal/services/company/controller"
)

type Service struct{}

func (*Service) Name() string {
	return "company"
}

func (*Service) Priority() int {
	return 1
}

func (s *Service) Init(context.Context) error {
	return nil
}

func (s *Service) Routes() []runtime.Routable {
	return []runtime.Routable{
		&controller.CompanyController{},
		&controller.CompanyDepartmentController{},
		&controller.CompanyEmployeeController{},
	}
}

func (s *Service) Start() error {
	return nil
}

func (s *Service) Stop() error {
	return nil
}
